diff --git a/contrib/pg_stat_statements/pg_stat_statements.c b/contrib/pg_stat_statements/pg_stat_statements.c
index 92315627916..2004cad91f7 100644
--- a/contrib/pg_stat_statements/pg_stat_statements.c
+++ b/contrib/pg_stat_statements/pg_stat_statements.c
@@ -2036,196 +1864,296 @@ pg_stat_statements_internal(FunctionCallInfo fcinfo,
 Datum
 pg_stat_statements_info(PG_FUNCTION_ARGS)
 {
-	pgssGlobalStats stats;
 	TupleDesc	tupdesc;
 	Datum		values[PG_STAT_STATEMENTS_INFO_COLS] = {0};
 	bool		nulls[PG_STAT_STATEMENTS_INFO_COLS] = {0};
 
-	if (!pgss || !pgss_hash)
-		ereport(ERROR,
-				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
-				 errmsg("pg_stat_statements must be loaded via \"shared_preload_libraries\"")));
-
-	/* Build a tuple descriptor for our result type */
 	if (get_call_result_type(fcinfo, NULL, &tupdesc) != TYPEFUNC_COMPOSITE)
 		elog(ERROR, "return type must be a row type");
 
-	/* Read global statistics for pg_stat_statements */
-	SpinLockAcquire(&pgss->mutex);
-	stats = pgss->stats;
-	SpinLockRelease(&pgss->mutex);
+	pgss_attach_shmem();
 
-	values[0] = Int64GetDatum(stats.dealloc);
-	values[1] = TimestampTzGetDatum(stats.stats_reset);
+	values[0] = Int64GetDatum((int64) pg_atomic_read_u64(&pgss_shared->dealloc));
+	values[1] = TimestampTzGetDatum(pgss_shared->stats_reset);
 
 	PG_RETURN_DATUM(HeapTupleGetDatum(heap_form_tuple(tupdesc, values, nulls)));
 }
 
 /*
- * Allocate a new hashtable entry.
- * caller must hold an exclusive lock on pgss->lock
+ * Evict entries using clock-sweep with reference count decay.
  *
- * "query" need not be null-terminated; we rely on query_len instead
+ * Multiple backends can sweep concurrently, each claiming the next partition
+ * via atomic increment of sweep_partition (rotating hand).  Each backend
+ * sweeps one partition per invocation: decrementing refcounts and evicting
+ * entries that reach zero via dshash_delete_current.  Entries still above 0
+ * survive.  Hot queries that execute frequently keep their refcount topped
+ * up (capped at PGSS_REF_CAP), giving them proportional protection.
  *
- * If "sticky" is true, make the new entry artificially sticky so that it will
- * probably still be there when the query finishes execution.  We do this by
- * giving it a median usage value rather than the normal value.  (Strictly
- * speaking, query strings are normalized on a best effort basis, though it
- * would be difficult to demonstrate this even under artificial conditions.)
+ * The hand advances across invocations so each sweep picks up where the last
+ * one left off, providing clock-sweep behavior.  Eviction stops within a
+ * partition as soon as nentries drops back to pgss_max.
  *
- * Note: despite needing exclusive lock, it's not an error for the target
- * entry to already exist.  This is because pgss_store releases and
- * reacquires lock after failing to find a match; so someone else could
- * have made the entry while we waited to get exclusive lock.
+ * Note: the partition swept is determined by the rotating hand, not by the
+ * key just inserted.  Eviction is a continuous background pressure mechanism
+ * to keep total entries near pgss_max, not a targeted operation to make room
+ * for the current entry specifically.
+ *
+ * Guaranteed eviction: any entry that stops being accessed will reach 0
+ * after at most PGSS_REF_CAP sweeps.
  */
-static pgssEntry *
-entry_alloc(pgssHashKey *key, Size query_offset, int query_len, int encoding,
-			bool sticky)
+static void
+entry_dealloc(void)
 {
+	dshash_seq_status status;
 	pgssEntry  *entry;
-	bool		found;
+	int			nentries;
+	int			evicted = 0;
+	uint32		my_partition;
+	uint32		sweep_val;
+	uint32		cur;
+
+	nentries = (int) pg_atomic_read_u64(&pgss_shared->nentries);
+	if (nentries <= pgss_max)
+		return;
 
-	/* Make space if needed */
-	while (hash_get_num_entries(pgss_hash) >= pgss_max)
-		entry_dealloc();
+	/*
+	 * Claim the next partition by atomically advancing the hand.  Multiple
+	 * backends can sweep concurrently, each on a different partition.
+	 */
+	sweep_val = pg_atomic_fetch_add_u32(&pgss_shared->sweep_partition, 1);
+	my_partition = sweep_val % DSHASH_NUM_PARTITIONS;
 
-	/* Find or create an entry with desired hash code */
-	entry = (pgssEntry *) hash_search(pgss_hash, key, HASH_ENTER, &found);
+	/* Re-check: another backend may have already resolved the overshoot */
+	if ((int) pg_atomic_read_u64(&pgss_shared->nentries) <= pgss_max)
+		return;
 
-	if (!found)
+	/*
+	 * Sweep one partition: decrement each entry's refcount, evict entries
+	 * that reach zero.  Stop if nentries drops back to pgss_max.
+	 */
+	dshash_seq_init_partition(&status, pgss_hash, true, my_partition);
+	while ((entry = dshash_seq_next(&status)) != NULL)
 	{
-		/* New entry, initialize it */
-
-		/* reset the statistics */
-		memset(&entry->counters, 0, sizeof(Counters));
-		/* set the appropriate initial usage count */
-		entry->counters.usage = sticky ? pgss->cur_median_usage : USAGE_INIT;
-		/* re-initialize the mutex each time ... we assume no one using it */
-		SpinLockInit(&entry->mutex);
-		/* ... and don't forget the query text metadata */
-		Assert(query_len >= 0);
-		entry->query_offset = query_offset;
-		entry->query_len = query_len;
-		entry->encoding = encoding;
-		entry->stats_since = GetCurrentTimestamp();
-		entry->minmax_stats_since = entry->stats_since;
-	}
+		if ((int) pg_atomic_read_u64(&pgss_shared->nentries) <= pgss_max * (100 - USAGE_DEALLOC_PERCENT) / 100)
+			break;
 
-	return entry;
-}
+		/*
+		 * Decrement refcount; evict if it reaches zero.  Guard against
+		 * underflow — a prior sweep may have already decremented to zero
+		 * without evicting (because nentries dropped below threshold). No CAS
+		 * needed: we hold the partition lock exclusively.
+		 */
+		cur = pg_atomic_read_u32(&entry->refcount);
+		if (cur > 0)
+		{
+			pg_atomic_write_u32(&entry->refcount, cur - 1);
+			if (cur - 1 > 0)
+				continue;
+		}
 
-/*
- * qsort comparator for sorting into increasing usage order
- */
-static int
-entry_cmp(const void *lhs, const void *rhs)
-{
-	double		l_usage = (*(pgssEntry *const *) lhs)->counters.usage;
-	double		r_usage = (*(pgssEntry *const *) rhs)->counters.usage;
+		/* Evict: drop from pgstat, then delete from dshash */
+		pgstat_drop_entry(PGSTAT_KIND_PGSS, entry->key.dbid,
+						  pgss_hash_key(&entry->key), true);
 
-	if (l_usage < r_usage)
-		return -1;
-	else if (l_usage > r_usage)
-		return +1;
-	else
-		return 0;
+		dshash_delete_current(&status);
+		pg_atomic_fetch_sub_u64(&pgss_shared->nentries, 1);
+		evicted++;
+	}
+	dshash_seq_term(&status);
+
+	if (evicted > 0)
+	{
+		pg_atomic_fetch_add_u64(&pgss_shared->dealloc, evicted);
+
+		/* Request pgstat entry ref GC once per full rotation */
+		if (my_partition == DSHASH_NUM_PARTITIONS - 1)
+			pgstat_request_entry_refs_gc();
+	}
 }
 
 /*
- * Deallocate least-used entries.
- *
- * Caller must hold an exclusive lock on pgss->lock.
+ * Reset entries corresponding to parameters passed.
+ * Iterates the dshash to find matching entries, deletes them from the
+ * dshash, and drops their pgstat entries.
  */
-static void
-entry_dealloc(void)
+static TimestampTz
+entry_reset(Oid userid, Oid dbid, int64 queryid, bool minmax_only)
 {
-	HASH_SEQ_STATUS hash_seq;
-	pgssEntry **entries;
+	dshash_seq_status status;
 	pgssEntry  *entry;
-	int			nvictims;
-	int			i;
-	Size		tottextlen;
-	int			nvalidtexts;
+	TimestampTz stats_reset;
+	int64		num_entries;
+	int64		num_remove = 0;
 
-	/*
-	 * Sort entries by usage and deallocate USAGE_DEALLOC_PERCENT of them.
-	 * While we're scanning the table, apply the decay factor to the usage
-	 * values, and update the mean query length.
-	 *
-	 * Note that the mean query length is almost immediately obsolete, since
-	 * we compute it before not after discarding the least-used entries.
-	 * Hopefully, that doesn't affect the mean too much; it doesn't seem worth
-	 * making two passes to get a more current result.  Likewise, the new
-	 * cur_median_usage includes the entries we're about to zap.
-	 */
+	pgss_attach_shmem();
 
-	entries = palloc(hash_get_num_entries(pgss_hash) * sizeof(pgssEntry *));
+	/* Flush pending stats before reset so we don't re-create dropped entries */
+	pgstat_report_anytime_stat();
 
-	i = 0;
-	tottextlen = 0;
-	nvalidtexts = 0;
+	stats_reset = GetCurrentTimestamp();
+	num_entries = (int64) pg_atomic_read_u64(&pgss_shared->nentries);
 
-	hash_seq_init(&hash_seq, pgss_hash);
-	while ((entry = hash_seq_search(&hash_seq)) != NULL)
+	if (minmax_only)
 	{
-		entries[i++] = entry;
-		/* "Sticky" entries get a different usage decay rate. */
-		if (IS_STICKY(entry->counters))
-			entry->counters.usage *= STICKY_DECREASE_FACTOR;
-		else
-			entry->counters.usage *= USAGE_DECREASE_FACTOR;
-		/* In the mean length computation, ignore dropped texts. */
-		if (entry->query_len >= 0)
+		/*
+		 * Reset only min/max timing values and update minmax_stats_since.
+		 * Iterate matching entries in the dshash, reset the corresponding
+		 * pgstat counters' min/max fields.
+		 */
+		dshash_seq_init(&status, pgss_hash, true);
+		while ((entry = dshash_seq_next(&status)) != NULL)
 		{
-			tottextlen += entry->query_len + 1;
-			nvalidtexts++;
+			if ((!userid || entry->key.userid == userid) &&
+				(!dbid || entry->key.dbid == dbid) &&
+				(!queryid || entry->key.queryid == queryid))
+			{
+				uint64		objid = pgss_hash_key(&entry->key);
+				PgStat_EntryRef *entry_ref;
+
+				entry->minmax_stats_since = stats_reset;
+
+				entry_ref = pgstat_get_entry_ref(PGSTAT_KIND_PGSS,
+												 entry->key.dbid, objid,
+												 false, NULL);
+				if (entry_ref)
+				{
+					PgStatShared_Pgss *shared;
+
+					shared = (PgStatShared_Pgss *) entry_ref->shared_stats;
+					if (!pgstat_lock_entry(entry_ref, false))
+						continue;
+
+					for (int kind = 0; kind < PGSS_NUMKIND; kind++)
+					{
+						shared->counters.min_time[kind] = 0;
+						shared->counters.max_time[kind] = 0;
+						shared->counters.mean_time[kind] = 0;
+						shared->counters.sum_var_time[kind] = 0;
+					}
+
+					pgstat_unlock_entry(entry_ref);
+				}
+			}
 		}
+		dshash_seq_term(&status);
+
+		return stats_reset;
 	}
 
-	/* Sort into increasing order by usage */
-	qsort(entries, i, sizeof(pgssEntry *), entry_cmp);
+	if (userid != 0 && dbid != 0 && queryid != INT64CONST(0))
+	{
+		/*
+		 * Fast path: specific entry identified by all three key components.
+		 * Try both toplevel=true and toplevel=false.
+		 */
+		pgssHashKey key;
 
-	/* Record the (approximate) median usage */
-	if (i > 0)
-		pgss->cur_median_usage = entries[i / 2]->counters.usage;
-	/* Record the mean query length */
-	if (nvalidtexts > 0)
-		pgss->mean_query_len = tottextlen / nvalidtexts;
-	else
-		pgss->mean_query_len = ASSUMED_LENGTH_INIT;
+		memset(&key, 0, sizeof(pgssHashKey));
+		key.userid = userid;
+		key.dbid = dbid;
+		key.queryid = queryid;
+
+		key.toplevel = false;
+		entry = dshash_find(pgss_hash, &key, true);
+		if (entry)
+		{
+			uint64		objid = pgss_hash_key(&key);
+
+			dshash_delete_entry(pgss_hash, entry);
+			pg_atomic_fetch_sub_u64(&pgss_shared->nentries, 1);
+			num_remove++;
 
-	/* Now zap an appropriate fraction of lowest-usage entries */
-	nvictims = Max(10, i * USAGE_DEALLOC_PERCENT / 100);
-	nvictims = Min(nvictims, i);
+			if (!pgstat_drop_entry(PGSTAT_KIND_PGSS, key.dbid, objid, true))
+				pgstat_request_entry_refs_gc();
+		}
+
+		key.toplevel = true;
+		entry = dshash_find(pgss_hash, &key, true);
+		if (entry)
+		{
+			uint64		objid = pgss_hash_key(&key);
 
-	for (i = 0; i < nvictims; i++)
+			dshash_delete_entry(pgss_hash, entry);
+			pg_atomic_fetch_sub_u64(&pgss_shared->nentries, 1);
+			num_remove++;
+
+			if (!pgstat_drop_entry(PGSTAT_KIND_PGSS, key.dbid, objid, true))
+				pgstat_request_entry_refs_gc();
+		}
+	}
+	else
 	{
-		hash_search(pgss_hash, &entries[i]->key, HASH_REMOVE, NULL);
+		/* Iterate all entries and remove those matching the filter */
+		dshash_seq_init(&status, pgss_hash, true);
+		while ((entry = dshash_seq_next(&status)) != NULL)
+		{
+			if ((!userid || entry->key.userid == userid) &&
+				(!dbid || entry->key.dbid == dbid) &&
+				(!queryid || entry->key.queryid == queryid))
+			{
+				pgssHashKey ekey = entry->key;
+				uint64		objid = pgss_hash_key(&ekey);
+
+				dshash_delete_current(&status);
+				pg_atomic_fetch_sub_u64(&pgss_shared->nentries, 1);
+				num_remove++;
+
+				if (!pgstat_drop_entry(PGSTAT_KIND_PGSS, ekey.dbid, objid, true))
+					pgstat_request_entry_refs_gc();
+			}
+		}
+		dshash_seq_term(&status);
 	}
 
-	pfree(entries);
+	/* If all entries were removed, reset global statistics and text file */
+	if (num_remove > 0 && num_entries == num_remove)
+	{
+		FILE	   *qfile;
+
+		pg_atomic_write_u64(&pgss_shared->dealloc, 0);
+		pgss_shared->stats_reset = stats_reset;
+
+		/* Write new empty query file */
+		qfile = AllocateFile(PGSS_TEXT_FILE, PG_BINARY_W);
+		if (qfile == NULL)
+		{
+			ereport(LOG,
+					(errcode_for_file_access(),
+					 errmsg("could not create file \"%s\": %m",
+							PGSS_TEXT_FILE)));
+		}
+		else
+		{
+			if (ftruncate(fileno(qfile), 0) != 0)
+				ereport(LOG,
+						(errcode_for_file_access(),
+						 errmsg("could not truncate file \"%s\": %m",
+								PGSS_TEXT_FILE)));
+			FreeFile(qfile);
+		}
+
+		SpinLockAcquire(&pgss_shared->mutex);
+		pgss_shared->extent = 0;
+		SpinLockRelease(&pgss_shared->mutex);
+		record_gc_qtexts();
+	}
 
-	/* Increment the number of times entries are deallocated */
-	SpinLockAcquire(&pgss->mutex);
-	pgss->stats.dealloc += 1;
-	SpinLockRelease(&pgss->mutex);
+	return stats_reset;
 }
 
+/*--------------------------------------------------------------------------
+ * Query text file management
+ *--------------------------------------------------------------------------
+ */
+
 /*
- * Given a query string (not necessarily null-terminated), allocate a new
- * entry in the external query text file and store the string there.
+ * Store query text in the external file.
  *
  * If successful, returns true, and stores the new entry's offset in the file
  * into *query_offset.  Also, if gc_count isn't NULL, *gc_count is set to the
  * number of garbage collections that have occurred so far.
  *
  * On failure, returns false.
- *
- * At least a shared lock on pgss->lock must be held by the caller, so as
- * to prevent a concurrent garbage collection.  Share-lock-holding callers
- * should pass a gc_count pointer to obtain the number of garbage collections,
- * so that they can recheck the count after obtaining exclusive lock to
- * detect whether a garbage collection occurred (and removed this entry).
  */
 static bool
 qtext_store(const char *query, int query_len,
@@ -2238,13 +2166,13 @@ qtext_store(const char *query, int query_len,
 	 * We use a spinlock to protect extent/n_writers/gc_count, so that
 	 * multiple processes may execute this function concurrently.
 	 */
-	SpinLockAcquire(&pgss->mutex);
-	off = pgss->extent;
-	pgss->extent += query_len + 1;
-	pgss->n_writers++;
+	SpinLockAcquire(&pgss_shared->mutex);
+	off = pgss_shared->extent;
+	pgss_shared->extent += query_len + 1;
+	pgss_shared->n_writers++;
 	if (gc_count)
-		*gc_count = pgss->gc_count;
-	SpinLockRelease(&pgss->mutex);
+		*gc_count = pgss_shared->gc_count;
+	SpinLockRelease(&pgss_shared->mutex);
 
 	*query_offset = off;
 
@@ -2255,7 +2183,7 @@ qtext_store(const char *query, int query_len,
 	 */
 	if (unlikely(query_len >= MaxAllocHugeSize - off))
 	{
-		errno = EFBIG;			/* not quite right, but it'll do */
+		errno = EFBIG;
 		fd = -1;
 		goto error;
 	}
@@ -2273,9 +2201,9 @@ qtext_store(const char *query, int query_len,
 	CloseTransientFile(fd);
 
 	/* Mark our write complete */
-	SpinLockAcquire(&pgss->mutex);
-	pgss->n_writers--;
-	SpinLockRelease(&pgss->mutex);
+	SpinLockAcquire(&pgss_shared->mutex);
+	pgss_shared->n_writers--;
+	SpinLockRelease(&pgss_shared->mutex);
 
 	return true;
 
@@ -2289,9 +2217,9 @@ error:
 		CloseTransientFile(fd);
 
 	/* Mark our write complete */
-	SpinLockAcquire(&pgss->mutex);
-	pgss->n_writers--;
-	SpinLockRelease(&pgss->mutex);
+	SpinLockAcquire(&pgss_shared->mutex);
+	pgss_shared->n_writers--;
+	SpinLockRelease(&pgss_shared->mutex);
 
 	return false;
 }
@@ -2303,9 +2231,6 @@ error:
  * file not there or insufficient memory.
  *
  * On success, the buffer size is also returned into *buffer_size.
- *
- * This can be called without any lock on pgss->lock, but in that case
- * the caller is responsible for verifying that the result is sane.
  */
 static char *
 qtext_load_file(Size *buffer_size)
@@ -2354,22 +2279,14 @@ qtext_load_file(Size *buffer_size)
 	}
 
 	/*
-	 * OK, slurp in the file.  Windows fails if we try to read more than
-	 * INT_MAX bytes at once, and other platforms might not like that either,
-	 * so read a very large file in 1GB segments.
+	 * OK, slurp in the file.  Read in 1GB segments to avoid issues on some
+	 * platforms.
 	 */
 	nread = 0;
 	while (nread < stat.st_size)
 	{
 		int			toread = Min(1024 * 1024 * 1024, stat.st_size - nread);
 
-		/*
-		 * If we get a short read and errno doesn't get set, the reason is
-		 * probably that garbage collection truncated the file since we did
-		 * the fstat(), so we don't log a complaint --- but we don't return
-		 * the data, either, since it's most likely corrupt due to concurrent
-		 * writes from garbage collection.
-		 */
 		errno = 0;
 		if (read(fd, buf + nread, toread) != toread)
 		{
@@ -2421,37 +2338,39 @@ qtext_fetch(Size query_offset, int query_len,
 /*
  * Do we need to garbage-collect the external query text file?
  *
- * Caller should hold at least a shared lock on pgss->lock.
+ * We check whether the file has grown excessively relative to the number
+ * of entries tracked.
  */
 static bool
 need_gc_qtexts(void)
 {
 	Size		extent;
+	int			nentries;
 
 	/* Read shared extent pointer */
-	SpinLockAcquire(&pgss->mutex);
-	extent = pgss->extent;
-	SpinLockRelease(&pgss->mutex);
+	SpinLockAcquire(&pgss_shared->mutex);
+	extent = pgss_shared->extent;
+	SpinLockRelease(&pgss_shared->mutex);
+
+	nentries = (int) pg_atomic_read_u64(&pgss_shared->nentries);
 
 	/*
 	 * Don't proceed if file does not exceed 512 bytes per possible entry.
-	 *
-	 * Here and in the next test, 32-bit machines have overflow hazards if
-	 * pgss_max and/or mean_query_len are large.  Force the multiplications
-	 * and comparisons to be done in uint64 arithmetic to forestall trouble.
 	 */
 	if ((uint64) extent < (uint64) 512 * pgss_max)
 		return false;
 
 	/*
-	 * Don't proceed if file is less than about 50% bloat.  Nothing can or
-	 * should be done in the event of unusually large query texts accounting
-	 * for file's large size.  We go to the trouble of maintaining the mean
-	 * query length in order to prevent garbage collection from thrashing
-	 * uselessly.
+	 * Don't proceed if file is less than about 50% bloat.  We estimate mean
+	 * query length from the file size and entry count.
 	 */
-	if ((uint64) extent < (uint64) pgss->mean_query_len * pgss_max * 2)
-		return false;
+	if (nentries > 0)
+	{
+		Size		mean_query_len = extent / nentries;
+
+		if ((uint64) extent < (uint64) mean_query_len * pgss_max * 2)
+			return false;
+	}
 
 	return true;
 }
@@ -2459,18 +2378,14 @@ need_gc_qtexts(void)
 /*
  * Garbage-collect orphaned query texts in external file.
  *
- * This won't be called often in the typical case, since it's likely that
- * there won't be too much churn, and besides, a similar compaction process
- * occurs when serializing to disk at shutdown or as part of resetting.
- * Despite this, it seems prudent to plan for the edge case where the file
- * becomes unreasonably large, with no other method of compaction likely to
- * occur in the foreseeable future.
+ * This rewrites the query text file, keeping only texts referenced by
+ * current dshash entries, and updates their offsets accordingly.
  *
- * The caller must hold an exclusive lock on pgss->lock.
- *
- * At the first sign of trouble we unlink the query text file to get a clean
- * slate (although existing statistics are retained), rather than risk
- * thrashing by allowing the same problem case to recur indefinitely.
+ * Note: unlike the upstream implementation which required LWLock exclusive,
+ * this uses dshash partition-level exclusive locks via sequential scan with
+ * exclusive=true.  This is safe because we're updating entry offsets in-place
+ * and the file is guaranteed not to grow during GC (no new writers can get
+ * offsets into the old region after we've reset the extent).
  */
 static void
 gc_qtexts(void)
@@ -2478,25 +2393,16 @@ gc_qtexts(void)
 	char	   *qbuffer;
 	Size		qbuffer_size;
 	FILE	   *qfile = NULL;
-	HASH_SEQ_STATUS hash_seq;
+	dshash_seq_status status;
 	pgssEntry  *entry;
 	Size		extent;
-	int			nentries;
 
-	/*
-	 * When called from pgss_store, some other session might have proceeded
-	 * with garbage collection in the no-lock-held interim of lock strength
-	 * escalation.  Check once more that this is actually necessary.
-	 */
 	if (!need_gc_qtexts())
 		return;
 
 	/*
 	 * Load the old texts file.  If we fail (out of memory, for instance),
-	 * invalidate query texts.  Hopefully this is rare.  It might seem better
-	 * to leave things alone on an OOM failure, but the problem is that the
-	 * file is only going to get bigger; hoping for a future non-OOM result is
-	 * risky and can easily lead to complete denial of service.
+	 * invalidate query texts.
 	 */
 	qbuffer = qtext_load_file(&qbuffer_size);
 	if (qbuffer == NULL)
@@ -2504,9 +2410,7 @@ gc_qtexts(void)
 
 	/*
 	 * We overwrite the query texts file in place, so as to reduce the risk of
-	 * an out-of-disk-space failure.  Since the file is guaranteed not to get
-	 * larger, this should always work on traditional filesystems; though we
-	 * could still lose on copy-on-write filesystems.
+	 * an out-of-disk-space failure.
 	 */
 	qfile = AllocateFile(PGSS_TEXT_FILE, PG_BINARY_W);
 	if (qfile == NULL)
@@ -2519,10 +2423,9 @@ gc_qtexts(void)
 	}
 
 	extent = 0;
-	nentries = 0;
 
-	hash_seq_init(&hash_seq, pgss_hash);
-	while ((entry = hash_seq_search(&hash_seq)) != NULL)
+	dshash_seq_init(&status, pgss_hash, true);
+	while ((entry = dshash_seq_next(&status)) != NULL)
 	{
 		int			query_len = entry->query_len;
 		char	   *qry = qtext_fetch(entry->query_offset,
@@ -2535,7 +2438,6 @@ gc_qtexts(void)
 			/* Trouble ... drop the text */
 			entry->query_offset = 0;
 			entry->query_len = -1;
-			/* entry will not be counted in mean query length computation */
 			continue;
 		}
 
@@ -2545,18 +2447,17 @@ gc_qtexts(void)
 					(errcode_for_file_access(),
 					 errmsg("could not write file \"%s\": %m",
 							PGSS_TEXT_FILE)));
-			hash_seq_term(&hash_seq);
+			dshash_seq_term(&status);
 			goto gc_fail;
 		}
 
 		entry->query_offset = extent;
 		extent += query_len + 1;
-		nentries++;
 	}
+	dshash_seq_term(&status);
 
 	/*
-	 * Truncate away any now-unused space.  If this fails for some odd reason,
-	 * we log it, but there's no need to fail.
+	 * Truncate away any now-unused space.
 	 */
 	if (ftruncate(fileno(qfile), extent) != 0)
 		ereport(LOG,
@@ -2575,29 +2476,15 @@ gc_qtexts(void)
 	}
 
 	elog(DEBUG1, "pgss gc of queries file shrunk size from %zu to %zu",
-		 pgss->extent, extent);
+		 pgss_shared->extent, extent);
 
 	/* Reset the shared extent pointer */
-	pgss->extent = extent;
-
-	/*
-	 * Also update the mean query length, to be sure that need_gc_qtexts()
-	 * won't still think we have a problem.
-	 */
-	if (nentries > 0)
-		pgss->mean_query_len = extent / nentries;
-	else
-		pgss->mean_query_len = ASSUMED_LENGTH_INIT;
+	SpinLockAcquire(&pgss_shared->mutex);
+	pgss_shared->extent = extent;
+	SpinLockRelease(&pgss_shared->mutex);
 
 	pfree(qbuffer);
 
-	/*
-	 * OK, count a garbage collection cycle.  (Note: even though we have
-	 * exclusive lock on pgss->lock, we must take pgss->mutex for this, since
-	 * other processes may examine gc_count while holding only the mutex.
-	 * Also, we have to advance the count *after* we've rewritten the file,
-	 * else other processes might not realize they read a stale file.)
-	 */
 	record_gc_qtexts();
 
 	return;
@@ -2611,14 +2498,15 @@ gc_fail:
 
 	/*
 	 * Since the contents of the external file are now uncertain, mark all
-	 * hashtable entries as having invalid texts.
+	 * dshash entries as having invalid texts.
 	 */
-	hash_seq_init(&hash_seq, pgss_hash);
-	while ((entry = hash_seq_search(&hash_seq)) != NULL)
+	dshash_seq_init(&status, pgss_hash, true);
+	while ((entry = dshash_seq_next(&status)) != NULL)
 	{
 		entry->query_offset = 0;
 		entry->query_len = -1;
 	}
+	dshash_seq_term(&status);
 
 	/*
 	 * Destroy the query text file and create a new, empty one
@@ -2634,160 +2522,11 @@ gc_fail:
 		FreeFile(qfile);
 
 	/* Reset the shared extent pointer */
-	pgss->extent = 0;
-
-	/* Reset mean_query_len to match the new state */
-	pgss->mean_query_len = ASSUMED_LENGTH_INIT;
-
-	/*
-	 * Bump the GC count even though we failed.
-	 *
-	 * This is needed to make concurrent readers of file without any lock on
-	 * pgss->lock notice existence of new version of file.  Once readers
-	 * subsequently observe a change in GC count with pgss->lock held, that
-	 * forces a safe reopen of file.  Writers also require that we bump here,
-	 * of course.  (As required by locking protocol, readers and writers don't
-	 * trust earlier file contents until gc_count is found unchanged after
-	 * pgss->lock acquired in shared or exclusive mode respectively.)
-	 */
-	record_gc_qtexts();
-}
-
-#define SINGLE_ENTRY_RESET(e) \
-if (e) { \
-	if (minmax_only) { \
-		/* When requested reset only min/max statistics of an entry */ \
-		for (int kind = 0; kind < PGSS_NUMKIND; kind++) \
-		{ \
-			e->counters.max_time[kind] = 0; \
-			e->counters.min_time[kind] = 0; \
-		} \
-		e->minmax_stats_since = stats_reset; \
-	} \
-	else \
-	{ \
-		/* Remove the key otherwise  */ \
-		hash_search(pgss_hash, &e->key, HASH_REMOVE, NULL); \
-		num_remove++; \
-	} \
-}
-
-/*
- * Reset entries corresponding to parameters passed.
- */
-static TimestampTz
-entry_reset(Oid userid, Oid dbid, int64 queryid, bool minmax_only)
-{
-	HASH_SEQ_STATUS hash_seq;
-	pgssEntry  *entry;
-	FILE	   *qfile;
-	int64		num_entries;
-	int64		num_remove = 0;
-	pgssHashKey key;
-	TimestampTz stats_reset;
-
-	if (!pgss || !pgss_hash)
-		ereport(ERROR,
-				(errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
-				 errmsg("pg_stat_statements must be loaded via \"shared_preload_libraries\"")));
-
-	LWLockAcquire(&pgss->lock.lock, LW_EXCLUSIVE);
-	num_entries = hash_get_num_entries(pgss_hash);
-
-	stats_reset = GetCurrentTimestamp();
-
-	if (userid != 0 && dbid != 0 && queryid != INT64CONST(0))
-	{
-		/* If all the parameters are available, use the fast path. */
-		memset(&key, 0, sizeof(pgssHashKey));
-		key.userid = userid;
-		key.dbid = dbid;
-		key.queryid = queryid;
-
-		/*
-		 * Reset the entry if it exists, starting with the non-top-level
-		 * entry.
-		 */
-		key.toplevel = false;
-		entry = (pgssEntry *) hash_search(pgss_hash, &key, HASH_FIND, NULL);
-
-		SINGLE_ENTRY_RESET(entry);
-
-		/* Also reset the top-level entry if it exists. */
-		key.toplevel = true;
-		entry = (pgssEntry *) hash_search(pgss_hash, &key, HASH_FIND, NULL);
-
-		SINGLE_ENTRY_RESET(entry);
-	}
-	else if (userid != 0 || dbid != 0 || queryid != INT64CONST(0))
-	{
-		/* Reset entries corresponding to valid parameters. */
-		hash_seq_init(&hash_seq, pgss_hash);
-		while ((entry = hash_seq_search(&hash_seq)) != NULL)
-		{
-			if ((!userid || entry->key.userid == userid) &&
-				(!dbid || entry->key.dbid == dbid) &&
-				(!queryid || entry->key.queryid == queryid))
-			{
-				SINGLE_ENTRY_RESET(entry);
-			}
-		}
-	}
-	else
-	{
-		/* Reset all entries. */
-		hash_seq_init(&hash_seq, pgss_hash);
-		while ((entry = hash_seq_search(&hash_seq)) != NULL)
-		{
-			SINGLE_ENTRY_RESET(entry);
-		}
-	}
-
-	/* All entries are removed? */
-	if (num_entries != num_remove)
-		goto release_lock;
-
-	/*
-	 * Reset global statistics for pg_stat_statements since all entries are
-	 * removed.
-	 */
-	SpinLockAcquire(&pgss->mutex);
-	pgss->stats.dealloc = 0;
-	pgss->stats.stats_reset = stats_reset;
-	SpinLockRelease(&pgss->mutex);
-
-	/*
-	 * Write new empty query file, perhaps even creating a new one to recover
-	 * if the file was missing.
-	 */
-	qfile = AllocateFile(PGSS_TEXT_FILE, PG_BINARY_W);
-	if (qfile == NULL)
-	{
-		ereport(LOG,
-				(errcode_for_file_access(),
-				 errmsg("could not create file \"%s\": %m",
-						PGSS_TEXT_FILE)));
-		goto done;
-	}
-
-	/* If ftruncate fails, log it, but it's not a fatal problem */
-	if (ftruncate(fileno(qfile), 0) != 0)
-		ereport(LOG,
-				(errcode_for_file_access(),
-				 errmsg("could not truncate file \"%s\": %m",
-						PGSS_TEXT_FILE)));
+	SpinLockAcquire(&pgss_shared->mutex);
+	pgss_shared->extent = 0;
+	SpinLockRelease(&pgss_shared->mutex);
 
-	FreeFile(qfile);
-
-done:
-	pgss->extent = 0;
-	/* This counts as a query text garbage collection for our purposes */
 	record_gc_qtexts();
-
-release_lock:
-	LWLockRelease(&pgss->lock.lock);
-
-	return stats_reset;
 }
 
 /*
diff --git a/contrib/pg_stat_statements/pg_stat_statements.conf b/contrib/pg_stat_statements/pg_stat_statements.conf
index 0e900d7119b..21a10c41d09 100644
--- a/contrib/pg_stat_statements/pg_stat_statements.conf
+++ b/contrib/pg_stat_statements/pg_stat_statements.conf
@@ -1,2 +1,3 @@
 shared_preload_libraries = 'pg_stat_statements'
 max_prepared_transactions = 5
+max_parallel_workers_per_gather = 0
diff --git a/contrib/pg_stat_statements/pg_stat_statements.control b/contrib/pg_stat_statements/pg_stat_statements.control
index 2eee0ceffa8..61ae41efc14 100644
--- a/contrib/pg_stat_statements/pg_stat_statements.control
+++ b/contrib/pg_stat_statements/pg_stat_statements.control
@@ -1,5 +1,5 @@
 # pg_stat_statements extension
 comment = 'track planning and execution statistics of all SQL statements executed'
-default_version = '1.13'
+default_version = '1.14'
 module_pathname = '$libdir/pg_stat_statements'
 relocatable = true
diff --git a/contrib/pg_stat_statements/sql/oldextversions.sql b/contrib/pg_stat_statements/sql/oldextversions.sql
index e416efe9ffb..b2090be6267 100644
--- a/contrib/pg_stat_statements/sql/oldextversions.sql
+++ b/contrib/pg_stat_statements/sql/oldextversions.sql
@@ -68,4 +68,9 @@ AlTER EXTENSION pg_stat_statements UPDATE TO '1.13';
 \d pg_stat_statements
 SELECT count(*) > 0 AS has_data FROM pg_stat_statements;
 
+-- Functions marked PARALLEL RESTRICTED in 1.14
+AlTER EXTENSION pg_stat_statements UPDATE TO '1.14';
+\d pg_stat_statements
+SELECT count(*) > 0 AS has_data FROM pg_stat_statements;
+
 DROP EXTENSION pg_stat_statements;
